local mod = ...



-- Balancing
mod:override({
    Id = "DEFAULT_BALANCING",
    PlantableList = {
        Action = "APPEND",
        "PLANTABLE_DESERT_TREE_PALM1",
        "PLANTABLE_DESERT_TREE_PALM2",
    },
    EventList = {
        Action = "APPEND", 
        "EVENT_ARCHIPELAGO_START",
    },
})



-- Event: Start ---------------------------------------------------------------------------------------------
mod:register({
    DataType = "EVENT",
    Id = "EVENT_ARCHIPELAGO_START",
    Title = "EVENT_ARCHIPELAGO_START_TITLE",
    Description = "EVENT_ARCHIPELAGO_START_DESC",
    IsInMainPool = false,
    IsRecurrent = false,
    DaysToFirst = 1,
    ConditionList = {
    },
	ActionList = {
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                DataType = "DATA_NARRATIVE_PANEL",
                Title = "EVENT_ARCHIPELAGO_START_TITLE",
                Description = "EVENT_ARCHIPELAGO_START_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_LABOR",
            },
            ChoiceList = {
                {
                    DataType = "EVENT_CHOICE",
                    ShortName = "EVENT_ARCHIPELAGO_OK",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_IGNORE"
                        },
                    },
                    OnClickCallbackList = nil
                },
            },
            OnClickCallback = nil
        },
    },
})



-- Assets -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Well1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })

mod:registerAssetId("models/Desert2.fbx/Prefab/TreePalm1", "PREFAB_DESERT_TREE_PALM1")
mod:registerAssetId("models/Desert2.fbx/Prefab/TreePalm2", "PREFAB_DESERT_TREE_PALM2")
mod:registerAssetId("models/Well1.fbx/Prefab/Well.Part.001", "PREFAB_ARCHIPELAGO_WELL1")
mod:registerAssetId("models/Well1.fbx/Prefab/Storage.Part.001", "PREFAB_ARCHIPELAGO_STORAGE1")

mod:registerAssetId("models/Volcano1.fbx/Prefab/Volcano1", "PREFAB_ARCHIPELAGO_VOLCANO1")
mod:registerAssetId("models/Volcano1.fbx/Prefab/Emitter1", "PREFAB_ARCHIPELAGO_EMITTER1")
mod:registerAssetId("models/Volcano1.fbx/Prefab/Emitter2", "PREFAB_ARCHIPELAGO_EMITTER2")



-- Terrain -------------------------------------------------------------------------------------
mod:registerPrefabComponent("PREFAB_ARCHIPELAGO_VOLCANO1", { DataType = "COMP_RIGID_BODY", Mass = 0 })
mod:configurePrefabFlagList("PREFAB_ARCHIPELAGO_VOLCANO1", { "TERRAIN" })



-- Grounding -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Well1.fbx/Prefab/Well.Part.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Well1.fbx/Prefab/Storage.Part.001/Barrel.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Well1.fbx/Prefab/Storage.Part.001/Barrel.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Well1.fbx/Prefab/Storage.Part.001/Barrel.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Well1.fbx/Prefab/Storage.Part.001/Bucket.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Well1.fbx/Prefab/Storage.Part.001/Bucket.002", {DataType = "COMP_GROUNDED"})



-- Dirt -------------------------------------------------------------------------------------
mod:registerPrefabComponent("PREFAB_ARCHIPELAGO_WELL1", {DataType = "COMP_DIRT_CIRCLE", HardRadius = 0.5, SoftRadius = 1 })



-- Plantable -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Desert2.fbx/Prefab/TreePalm1", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 14.0 })
mod:registerPrefabComponent("models/Desert2.fbx/Prefab/TreePalm1", { DataType = "COMP_TREE" })
mod:registerAssetId("icons/Palm1.png", "ICON_ARCHIPELAGO_PALM1", "ATLAS_CELL")

mod:register({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_DESERT_TREE_PALM1",
    Name = "PLANTABLE_DESERT_TREE_PALM_NAME",
    PlantPrefab = "PREFAB_DESERT_TREE_PALM1",
    Icon = "ICON_ARCHIPELAGO_PALM1",
    MinimumScale = 0.85, -- min size at full growth
    MaximumScale = 1.15 -- max size at full growth
})


mod:registerPrefabComponent("models/Desert2.fbx/Prefab/TreePalm2", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 14.0 })
mod:registerPrefabComponent("models/Desert2.fbx/Prefab/TreePalm2", { DataType = "COMP_TREE" })

mod:register({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_DESERT_TREE_PALM2",
    Name = "PLANTABLE_DESERT_TREE_PALM_NAME",
    PlantPrefab = "PREFAB_DESERT_TREE_PALM2",
    Icon = "ICON_ARCHIPELAGO_PALM1",
    MinimumScale = 0.85, -- min size at full growth
    MaximumScale = 1.15 -- max size at full growth
})



-- Resource container -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/Desert2.fbx/Prefab/TreePalm1", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "WOOD",
    IsReplenishable = false,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 1.3, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = true,
    HasMaximumWorkstation = false
})


mod:registerPrefabComponent( "models/Desert2.fbx/Prefab/TreePalm2", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "WOOD",
    IsReplenishable = false,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 1.3, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = true,
    HasMaximumWorkstation = false
})


mod:registerPrefabComponent( "PREFAB_ARCHIPELAGO_WELL1", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "WATER",
    IsReplenishable = true,
    ReplenishDurationInDays = 7,
    ReplenishQuantity = 250,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 100, -- maximum container stock
    Radius = 2, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false,
})



-- Resource: Water -------------------------------------------------------------------------------------
mod:override({
    Id = "WATER",
    VillagerBuyingPrice = {
        Resource = "GOLD_COINS",
        Quantity = 1,
    },
})



-- Building Function: Sell water to villagers -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_ARCHIPELAGO_WATER",
    Name = "BUILDING_FUNCTION_ARCHIPELAGO_WATER_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_ARCHIPELAGO_WATER",
        Behavior = "BEHAVIOR_GATHER"
    },
	TypeList = { "WATER" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 100,
	InputInventoryCapacity = {
		{ Resource = "WATER", Quantity = 100 },
	},
    ResourceListNeeded = {
		{ Resource = "WATER", Quantity = 25 },
	},
	ResourceProduced = {
		{ Resource = "WATER", Quantity = 25 },
	}
})



-- Job: Water Seller -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_ARCHIPELAGO_WATER",
	JobName = "JOB_ARCHIPELAGO_WATER_NAME",
	JobDescription = "JOB_ARCHIPELAGO_WATER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_GATHER",
    ProductionDelay = 1, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        RightHandObject = {
            Model = "PREFAB_TOOL_DAIRY_FARMER_BUCKET"
        },
        LeftHandObject = {
            Model = "PREFAB_TOOL_DAIRY_FARMER_BUCKET"
        },
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ARCHIPELAGO_WATER"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ARCHIPELAGO_WATER"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ARCHIPELAGO_WATER"
    }
})



-- Building Part: Well -------------------------------------------------------------------------------------
mod:override({
    Id = "BUILDING_WELL",
    Name = "BUILDING_PART_ARCHIPELAGO_WATER_NAME",
})

mod:override({
    Id = "BUILDING_PART_WELL",
    Name = "BUILDING_PART_ARCHIPELAGO_WATER_NAME",
    AssetBuildingFunction = "BUILDING_FUNCTION_ARCHIPELAGO_WATER",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ARCHIPELAGO_STORAGE1",
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 25.0
        },
    },
})

mod:override({
    Id = "WELLBALANCING_PART",
    Name = "BUILDING_PART_ARCHIPELAGO_WATER_NAME",
    AssetBuildingFunction = "BUILDING_FUNCTION_ARCHIPELAGO_WATER",
})



-- Textures and Materials -------------------------------------------------------------------------------------
mod:registerAssetId("models/textures/Fire.png", "TEXTURE_ARCHIPELAGO_FIRE")
mod:register({
	DataType = "MATERIAL",
	Id = "MATERIAL_ARCHIPELAGO_FIRE",
	AlbedoTexture = "TEXTURE_ARCHIPELAGO_FIRE"
})

mod:registerAssetId("models/textures/Smoke.png", "TEXTURE_ARCHIPELAGO_SMOKE")
mod:register({
	DataType = "MATERIAL",
	Id = "MATERIAL_ARCHIPELAGO_SMOKE",
	AlbedoTexture = "TEXTURE_ARCHIPELAGO_SMOKE"
})



-- Particle: Fire -------------------------------------------------------------------------------------
mod:register({
	DataType = "PARTICLE_SYSTEM",
	Id = "PARTICLE_SYSTEM_ARCHIPELAGO_FIRE1",
	Material = "MATERIAL_ARCHIPELAGO_FIRE",
	BillboardBehavior = "FACE_CAMERA",
	Duration = 10.0,
	LifeTime = 8.0,
	Looping = true,
	Delay = { 0, 0 },
	StartSpeed = { 0.1, 0.1 },
	StartSize = { 60.0, 60.0 },
	StartRotation = { 0, 0 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = -0.015,
	RateOverTime = 5,
    RateOverTimeRandom = 5,
	AlignWithVelocity = true,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 0.0,
		-- Radius = 0.0001,
		Radius = 0,
	},
    BurstList = {
        {
            DataType = "PARTICLE_BURST_DATA",
            Time = 0,
            Count = 10,
            Cycles = 3,
            Interval = 5.0,
        },
    },
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.1, 0, 0.1 },
		ValueB = { -0.1, 0, -0.1 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 0.5 } }
		},
		AlphaList = {
			{ T = 0.1, Alpha = 10 },
			{ T = 0.2, Alpha = 90 },
			{ T = 0.3, Alpha = 0 },
			{ T = 0.4, Alpha = 0 },
			{ T = 0.5, Alpha = 90 },
			{ T = 0.6, Alpha = 0 },
			{ T = 0.7, Alpha = 40 },
			{ T = 0.8, Alpha = 20 },
			{ T = 0.9, Alpha = 10 },
			{ T = 1, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0, Value = 0.1 },
			{ T = 0.5, Value = 0.2 },
			{ T = 1, Value = 0.3 }
	},
	RotationOverLifetime = { -70, 70 }
})

mod:registerPrefabComponent("PREFAB_ARCHIPELAGO_EMITTER1", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_ARCHIPELAGO_FIRE1",
	IsPlaying = true,
	IsEmitting = true
})



-- Particle: Smoke -------------------------------------------------------------------------------------
mod:register({
	DataType = "PARTICLE_SYSTEM",
	Id = "PARTICLE_SYSTEM_ARCHIPELAGO_SMOKE1",
	Material = "MATERIAL_ARCHIPELAGO_SMOKE",
	BillboardBehavior = "FACE_CAMERA",
	Duration = 16,
	LifeTime = 15,
	Looping = true,
	Delay = { 0, 0 },
	StartSpeed = { 0.2, 0.2 },
	StartSize = { 70.0, 70.0 },
	StartRotation = { 0, 0 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = -.05,
	RateOverTime = 2,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 0.1,
		Radius = 0.0001,
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.15, 0, 0.15 },
		ValueB = { -0.15, 0, -0.15 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 0.5 } }
		},
		AlphaList = {
			{ T = 0.1, Alpha = 0 },
			{ T = 0.2, Alpha = 20 },
			{ T = 0.4, Alpha = 30 },
			{ T = 0.6, Alpha = 40 },
			{ T = 0.7, Alpha = 80 },
			{ T = 0.8, Alpha = 30 },
			{ T = 1, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0.1, Value = 0.2 },
			{ T = 0.5, Value = 0.3 },
			{ T = 1, Value = 0.5 }
	},
	RotationOverLifetime = { -25, 25 }
})

mod:registerPrefabComponent("PREFAB_ARCHIPELAGO_EMITTER2", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_ARCHIPELAGO_SMOKE1",
	IsPlaying = true,
	IsEmitting = true
})